#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define SRC_IMAGE "src.jpg"
#define DEST_IMAGE "dest.jpg"
#define X_CUT 0
#define Y_CUT 0
#define WIDTH 50
#define HEIGHT 50

guint32 get_pixel(GdkPixbuf* pixbuf, int x, int y)
{
    guchar* pixels = gdk_pixbuf_get_pixels(pixbuf);
    return *((guint32*)(pixels +
            gdk_pixbuf_get_n_channels(pixbuf) * x +
            gdk_pixbuf_get_rowstride(pixbuf) * y));
}
int main()
{
    g_type_init();
    
    GdkPixbuf* src = gdk_pixbuf_new_from_file(SRC_IMAGE, NULL);
    GdkPixbuf* dest = gdk_pixbuf_new_from_file(DEST_IMAGE, NULL);
    
    GdkPixbuf* src_sub = gdk_pixbuf_new_subpixbuf(src, X_CUT, Y_CUT, WIDTH, HEIGHT);
    GdkPixbuf* dest_sub = gdk_pixbuf_new_subpixbuf(dest, X_CUT, Y_CUT, WIDTH, HEIGHT);
    
    int x = X_CUT + WIDTH, y = Y_CUT;
    printf("Pixel in dest image at (%d, %d) has value %x.\n", x, y, (guint32*)get_pixel(dest, x, y));
    
    printf("But after work with subpixbuf (%d - %d, %d - %d)\n",
        X_CUT, X_CUT + WIDTH - 1,
        Y_CUT, Y_CUT + HEIGHT - 1);
        
    gdk_pixbuf_saturate_and_pixelate(src_sub, dest_sub, 1.0, FALSE);
    
    printf("It's value changed to %x.\n", get_pixel(dest, x, y));
    
    g_object_unref(src_sub);
    g_object_unref(src);
    g_object_unref(dest_sub);
    g_object_unref(dest);
    
    return 0;

}